# Tutorials and Examples

This repository contains several tutorials and examples which show how to use LLGL.
Here is a brief overview:

## Tutorials

### [Hello Triangle](HelloTriangle)

Getting started tutorial where a single multi-colored triangle is rendered.

<p align="center"><img src="HelloTriangle/Example.png" width="400" height="300"/></p>


### [Tessellation](Tessellation)

Simple tessellation tutorial (without texturing).

<p align="center"><img src="Tessellation/Example.png" width="400" height="300"/></p>


## Examples

### [Texturing](Texturing)

Simple texturing and sampler state example.

<p align="center"><img src="Texturing/Example.png" width="400" height="300"/></p>


### [Queries](Queries)

Shows how to use Query objects and conditional rendering for occlusion culling.

<p align="center"><img src="Queries/Example.png" width="400" height="300"/></p>


### [Render Target](RenderTarget)

Simple render target example with optional multi-sample texture (Texture2DMS/ sampler2DMS).

<p align="center"><img src="RenderTarget/Example.png" width="400" height="300"/></p>


### [Multi Context](MultiContext)

Shows the following rendering techniques: multiple render contexts (one window each), rendering simultaneously into multiple viewports, geometry shader.

<p align="center"><img src="MultiContext/Example.png" width="752" height="300"/></p>


### [Buffer Array](BufferArray)

Shows how to use buffer arrays, i.e. render with multiple vertex buffers simultaneously, and hardware instancing.

<p align="center"><img src="BufferArray/Example.png" width="400" height="300"/></p>


### [Compute Shader](ComputeShader)

Small example with a compute shader and a storage buffer.

*No screenshot available*


### [Stream-Output](StreamOutput)

Small example with a geometry shader and a stream-output buffer.

<p align="center"><img src="StreamOutput/Example.png" width="400" height="300"/></p>


### [Instancing](Instancing)

Practical example of hardware instancing by rendering tens of thousands of different textured plants instances.

<p align="center"><img src="Instancing/Example.png" width="400" height="300"/></p>


### [Post-Processing](PostProcessing)

Practical example of a glow effect with post-processing and the usage of several shaders, render targets and graphics pipelines.

<p align="center"><img src="PostProcessing/Example.png" width="400" height="300"/></p>


### [Multi Renderer](MultiRenderer)

Experimental example of using multiple renderers at once (only supported on Win32 platform).

<p align="center"><img src="MultiRenderer/Example.png" width="400" height="300"/></p>


### [Shadow Mapping](ShadowMapping)

Practical example of standard shadow-mapping technique.

<p align="center"><img src="ShadowMapping/Example.png" width="400" height="300"/></p>



