/*
 * ForwardDecls.h
 * 
 * This file is part of the "LLGL" project (Copyright (c) 2015-2018 by Lukas Hermanns)
 * See "LICENSE.txt" for license information.
 */

#ifndef LLGL_FORWARD_DECLS_H
#define LLGL_FORWARD_DECLS_H


namespace LLGL
{


class Buffer;
class BufferArray;
class Canvas;
class CommandBuffer;
class CommandBufferExt;
class CommandQueue;
class ComputePipeline;
class Fence;
class GraphicsPipeline;
class Image;
class PipelineLayout;
class QueryHeap;
class RenderContext;
class RenderPass;
class RenderSystem;
class RenderTarget;
class Resource;
class ResourceHeap;
class Sampler;
class Shader;
class ShaderProgram;
class ShaderUniform;
class Surface;
class Texture;
class Timer;
class Window;

struct ApplicationDescriptor;
struct AttachmentClear;
struct AttachmentDescriptor;
struct AttachmentFormatDescriptor;
struct BindingDescriptor;
struct BlendDescriptor;
struct BlendTargetDescriptor;
struct BufferDescriptor;
struct CanvasDescriptor;
struct CommandBufferDescriptor;
struct ComputePipelineDescriptor;
struct DepthBiasDescriptor;
struct DepthDescriptor;
struct DisplayModeDescriptor;
struct DstImageDescriptor;
struct GraphicsPipelineDescriptor;
struct ImageInitialization;
struct MultiSamplingDescriptor;
struct OpenGLDependentStateDescriptor;
struct PipelineLayoutDescriptor;
struct ProfileOpenGLDescriptor;
struct QueryHeapDescriptor;
struct QueryPipelineStatistics;
struct RasterizerDescriptor;
struct RendererInfo;
struct RenderingFeatures;
struct RenderingLimits;
struct RenderingCapabilities;
struct RenderContextDescriptor;
struct RenderPassDescriptor;
struct RenderSystemConfiguration;
struct RenderSystemDescriptor;
struct RenderTargetDescriptor;
struct ResourceHeapDescriptor;
struct ResourceViewDescriptor;
struct SamplerDescriptor;
struct Scissor;
struct ShaderDescriptor;
struct ShaderProgramDescriptor;
struct ShaderReflectionDescriptor;
struct SrcImageDescriptor;
struct StencilDescriptor;
struct StencilFaceDescriptor;
struct StreamOutputAttribute;
struct StreamOutputFormat;
struct TextureDescriptor;
struct TextureRegion;
struct VertexAttribute;
struct VertexFormat;
struct VideoAdapterDescriptor;
struct VideoModeDescriptor;
struct VideoOutputDescriptor;
struct Viewport;
struct VsyncDescriptor;
struct VulkanRendererConfiguration;
struct WindowBehavior;
struct WindowDescriptor;


} // /namespace LLGL


#endif



// ================================================================================
